﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ChatServerOptions
{
    using System;
    using System.Collections.Generic;
    using System.Text;
    using System.Xml;
    using ChatData;
    using System.Security.Permissions;
    using System.Security;
    /// <summary>
    /// Reads and Writes UserStore collections to and from disk
    /// </summary>
    public class XML
    {
        public static void Write(UserStore<StoreRecord> items, string filename)
        {
            //FileIOPermission perm = new FileIOPermission(FileIOPermissionAccess.Write, filename);
            using (XmlTextWriter writer = new XmlTextWriter(filename, Encoding.Default))
            {
                try
                {
                    writer.WriteStartDocument();
                    writer.WriteStartElement("Users");
                    foreach (KeyValuePair<String, StoreRecord> entry in items)
                    {
                        StoreRecord temp = entry.Value;
                        writer.WriteStartElement("User");
                        writer.WriteElementString("Username", temp.Username);
                        writer.WriteElementString("Password", temp.Password);
                        writer.WriteElementString("IP", temp.Ip);
                        writer.WriteElementString("Port", temp.Port.ToString());
                        writer.WriteEndElement();
                    }
                    writer.WriteEndElement();
                    writer.WriteEndDocument();
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message);
                }
            }
            //CodeAccessPermission.RevertAssert();
        }
        public static UserStore<StoreRecord> Read(string filename)
        {
            //FileIOPermission perm = new FileIOPermission(FileIOPermissionAccess.Read, filename);
            if (System.IO.File.Exists(filename) != true)
            {
                return null;
            }
            UserStore<StoreRecord> theusers = new UserStore<StoreRecord>();
            try
            {
                XmlDocument doc = new XmlDocument();
                doc.Load(filename);

                XmlNodeList thelist = doc.SelectNodes("//User");
                

                foreach (XmlNode node in thelist)
                {
                    string user = node.ChildNodes[0].InnerText;
                     string pass = node.ChildNodes[1].InnerText;
                    string IP = node.ChildNodes[2].InnerText;
                    int port = int.Parse(node.ChildNodes[3].InnerText);
                    StoreRecord temp = new StoreRecord(user,IP,port,"",pass);
                   
                    theusers.Add(temp);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                Console.WriteLine("Empty File");
            }
            //CodeAccessPermission.RevertAssert();
            return theusers;

        }
    }
}

