﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using ChatData;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using System.Data.Services.Client;

namespace WCFServiceWebRole1
{
    public class StreamsDataSource
    {
        private StreamsDataServiceContext _ServiceContext = null;

        public StreamsDataSource(CloudStorageAccount storageAccount)
        {
            // var storageAccount = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");
            _ServiceContext = new StreamsDataServiceContext(storageAccount.TableEndpoint.ToString(), storageAccount.Credentials);

            // Create the tables
            // In this case, just a single table.  
            storageAccount.CreateCloudTableClient().CreateTableIfNotExist(StreamsDataServiceContext.StreamsTableName);
        }

        public IEnumerable<StreamsDataModel> Select()
        {
            var results = (from c in _ServiceContext.StreamsTable
                           select c).Take(100);

            var query = results.AsTableServiceQuery<StreamsDataModel>();
            var queryResults = query.Execute();

            return queryResults;
        }


        public  IEnumerable<StreamsDataModel> getStreamSince(DateTime dateTime)
        {
            var results = (from c in _ServiceContext.StreamsTable
                           where c.Time.isLaterThan(dateTime)
                           select c).Take(100);

            var query = results.AsTableServiceQuery<StreamsDataModel>();
            var queryResults = query.Execute();

            return queryResults;
        }

        public IEnumerable<StreamsDataModel> SelectStream()
        {
            return this.Select();
        }

        public void Insert(StreamsDataModel thepost)
        {
            _ServiceContext.UpdateObject(thepost);
            _ServiceContext.SaveChanges();
        }
    }
}
