﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Linq;
using ChatData;
using System.IO;
using WCFServiceWebRole1;


namespace ClientServerCloudOptions
{
    public partial class Options : Form
    {
        UserStore<StoreRecord> thestore = new UserStore<StoreRecord>();
        AdminServiceClient client;
        public Options(AdminServiceClient theclient)
        {
            InitializeComponent();

            client = theclient;

            thestore.AddUsersRange(client.getAllUsers());
            foreach (KeyValuePair<String, StoreRecord> item in thestore)
            {
                this.kryptonListBox2.Items.Add(item.Value.Username);
            }
        }
        public Options(UserStore<StoreRecord> e)
        {
            InitializeComponent();
            thestore = e;
            foreach (KeyValuePair<String,StoreRecord> item in thestore)
            {
                this.kryptonListBox2.Items.Add(item.Value.Username);
            }
        }
        private void Delete()
        {
            
            thestore.Remove(this.kryptonListBox2.SelectedItem.ToString());
            client.deleteUser(this.kryptonListBox2.SelectedItem.ToString());
            this.kryptonListBox2.Items.RemoveAt(this.kryptonListBox2.SelectedIndex);
        }

        private void edit()
        {
            string user= kryptonListBox2.SelectedItem.ToString();
            string pass= thestore.getPassword(user);
            using (EditUser dialog = new EditUser(user,pass))
            {
                System.Windows.Forms.DialogResult result = dialog.ShowDialog();
                if (result == DialogResult.Yes)
                {
                    StoreRecord temp = new StoreRecord();
                    temp.Username = dialog.Username;
                    temp.Password = Utils.EncodePasswordToBase64(dialog.Password);
                    temp.Ip = "";
                    temp.Port = 8080;
                    temp.Status = "";
                    client.editUser(temp);
                    thestore.Update(temp);
                }
            }
        }
        private void add()
        {
            using (AddUser dialog = new AddUser())
            {
                DialogResult result = dialog.ShowDialog();
                if (result == DialogResult.Yes)
                {
                    StoreRecord temp = new StoreRecord();
                    temp.Username= dialog.Username;
                    temp.Password = Utils.EncodePasswordToBase64(dialog.Password);
                    temp.Ip = "";
                    temp.Port = 8080;
                    temp.Status = "";
                    client.addUser(temp);
                    thestore.Add(temp);
                    this.kryptonListBox2.Items.Add(temp.Username);
                }
            }
        }

        public string Selection
        {
            get { return kryptonListBox2.SelectedItem.ToString(); }
        }
        //cancel
        private void kryptonButton2_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }
        private void kryptonButtonSave_Click(object sender, EventArgs e)
        {
            
            this.DialogResult = DialogResult.Yes;
            this.Close();
        }

        private void kryptonButton1_Click(object sender, EventArgs e)
        {
            Delete();
        }

        private void buttonSpecHeaderGroup2_Click(object sender, EventArgs e)
        {
            Delete();
        }

        private void buttonSpecHeaderGroup1_Click(object sender, EventArgs e)
        {
            add();
        }

        private void kryptonListBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.kryptonLabel2.Text = this.kryptonListBox2.SelectedItem.ToString();
            this.kryptonLabel1.Text = thestore.getStatus(this.kryptonListBox2.SelectedItem.ToString());
        }

        private void kryptonButton3_Click(object sender, EventArgs e)
        {
            edit();
        }
    }
}
